/*
 *              d b g a s s r t
 *
 * LIBDEBUG routine to print a failed assertion.
 *
 * It is intended to be used as a replacement for
 * the standard system library routine when the
 * DEBUG library is in use.  It uses a different
 * behavior in that it uses the debug window and
 * passes control to the DEBUG interpreter. The
 * user makes the decision on whether to abort the
 * program or to continue (possibly after doing
 * something within the DEBUG system to correct
 * the error.
 *
 * AMENDMENT HISTORY
 * ~~~~~~~~~~~~~~~~~
 *  18 Sep 99   DJW   - First version.  Based on the version in the
 *                      C68 for QDOS library.  May well need changing
 *                      or enhancing for other operating systems.
 */


#include "libdebug.h"

#include <assert.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

extern void     _Dbg_Commands (char * where, int level);
extern int  _DbgErrno;
extern int  _DbgOserr;

#ifdef QDOS

#include <qdos.h>

void _assert( char * mesg)
{
    char    message[512];

    _DbgErrno = errno;
    _DbgOserr = _oserr;
    /* 
     *  Construct the standard assertion message
     */
    (void) strcpy (message, _prog_name);
    (void) strcat (message, " - ");
    (void) strcat (message, mesg);
    (void) strcat (message, "\n --- assertion failed ---\n");
    /*
     *  Invoke the debugger
     */
    dbg_print ("\nASSERTION FAILURE\n%s", message);
    _Dbg_Commands (message, 0);

    errno = _DbgErrno;
    _oserr = _DbgOserr;
    return;
}
#endif /* QDOS */

